#ifndef __BENCHMARK_CPP_H_
#define __BENCHMARK_CPP_H_

#include <cstdlib>

class Vertex3D {
private:
	float x;
	float y;
	float z;
	
public:
	Vertex3D(float x, float y, float z) {
		this->x=x;
		this->y=y;
		this->z=z;
	}
	
	Vertex3D() {
		
	}
};

class Ray {
	
};

class GeometryObjectInfo {
	
};

class GeometryObject {
private:
	GeometryObjectInfo *info;
public:
	virtual bool intersect(Ray *ray)=0;
	virtual ~GeometryObject() {
		
	}
};

class Triangle : public GeometryObject {
private:
	Vertex3D point1;
	Vertex3D point2;
	Vertex3D point3;
public:
	virtual inline bool intersect(Ray *ray) {
		return rand() % 2;
	}
};

#endif /* __BENCHMARK_CPP_H_ */
